"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import luminarycloud._proto.client.simulation_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class GetChatSessionsRequest(google.protobuf.message.Message):
    """a request for getting sessions associated with the current project"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SCOPE_FIELD_NUMBER: builtins.int
    scope: builtins.str
    """the scope of the chat sessions"""
    def __init__(
        self,
        *,
        scope: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["scope", b"scope"]) -> None: ...

global___GetChatSessionsRequest = GetChatSessionsRequest

class GetChatSessionsResponse(google.protobuf.message.Message):
    """response from GetChatSessions"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_IDS_FIELD_NUMBER: builtins.int
    @property
    def session_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]: ...
    def __init__(
        self,
        *,
        session_ids: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["session_ids", b"session_ids"]) -> None: ...

global___GetChatSessionsResponse = GetChatSessionsResponse

class NewChatSessionRequest(google.protobuf.message.Message):
    """request to NewChatSession"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SCOPE_FIELD_NUMBER: builtins.int
    scope: builtins.str
    """the scope of the chat session"""
    def __init__(
        self,
        *,
        scope: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["scope", b"scope"]) -> None: ...

global___NewChatSessionRequest = NewChatSessionRequest

class NewChatSessionResponse(google.protobuf.message.Message):
    """response from NewChatSession"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_ID_FIELD_NUMBER: builtins.int
    session_id: builtins.str
    def __init__(
        self,
        *,
        session_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["session_id", b"session_id"]) -> None: ...

global___NewChatSessionResponse = NewChatSessionResponse

class Request(google.protobuf.message.Message):
    """a request from user to assist."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_FIELD_NUMBER: builtins.int
    REQUEST_FIELD_NUMBER: builtins.int
    CMD_FIELD_NUMBER: builtins.int
    ACCESS_FIELD_NUMBER: builtins.int
    SCOPE_FIELD_NUMBER: builtins.int
    session: builtins.str
    """id of the long lived session, an opaque string set by initiator"""
    request: builtins.str
    """id of current chat, an opaque string set by initiator"""
    cmd: builtins.str
    """the text user entered to make the request"""
    access: builtins.str
    """the access tokens for assistant to act on behalf of the user"""
    scope: builtins.str
    def __init__(
        self,
        *,
        session: builtins.str = ...,
        request: builtins.str = ...,
        cmd: builtins.str = ...,
        access: builtins.str = ...,
        scope: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["access", b"access", "cmd", b"cmd", "request", b"request", "scope", b"scope", "session", b"session"]) -> None: ...

global___Request = Request

class Reply(google.protobuf.message.Message):
    """responses from assistant to request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_FIELD_NUMBER: builtins.int
    REQUEST_FIELD_NUMBER: builtins.int
    LAST_FIELD_NUMBER: builtins.int
    ACTION_FIELD_NUMBER: builtins.int
    RESPONSE_FIELD_NUMBER: builtins.int
    session: builtins.str
    """id of the session"""
    request: builtins.str
    """id of current chat"""
    last: builtins.bool
    """indicates if session is closing"""
    @property
    def action(self) -> global___Action:
        """request to run a predefined action"""
    response: builtins.str
    """show a response to the user"""
    def __init__(
        self,
        *,
        session: builtins.str = ...,
        request: builtins.str = ...,
        last: builtins.bool = ...,
        action: global___Action | None = ...,
        response: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["action", b"action", "response", b"response", "step", b"step"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["action", b"action", "last", b"last", "request", b"request", "response", b"response", "session", b"session", "step", b"step"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["step", b"step"]) -> typing_extensions.Literal["action", "response"] | None: ...

global___Reply = Reply

class Action(google.protobuf.message.Message):
    """a request by assistant to a user visible action"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PARAMS_FIELD_NUMBER: builtins.int
    name: builtins.str
    """the operation name"""
    @property
    def params(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """parameters to pass, each is individually json encoded"""
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        params: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["name", b"name", "params", b"params"]) -> None: ...

global___Action = Action

class Outcome(google.protobuf.message.Message):
    """a response to a action request"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_FIELD_NUMBER: builtins.int
    REQUEST_FIELD_NUMBER: builtins.int
    VAL_FIELD_NUMBER: builtins.int
    ERR_FIELD_NUMBER: builtins.int
    session: builtins.str
    """id of the session"""
    request: builtins.str
    """id of current chat"""
    val: builtins.str
    """json encoded return value, if successful"""
    err: builtins.str
    """error that resulted, if failure"""
    def __init__(
        self,
        *,
        session: builtins.str = ...,
        request: builtins.str = ...,
        val: builtins.str = ...,
        err: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["err", b"err", "result", b"result", "val", b"val"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["err", b"err", "request", b"request", "result", b"result", "session", b"session", "val", b"val"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["result", b"result"]) -> typing_extensions.Literal["val", "err"] | None: ...

global___Outcome = Outcome

class GetChatHistoryRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SESSION_FIELD_NUMBER: builtins.int
    SCOPE_FIELD_NUMBER: builtins.int
    session: builtins.str
    """id of the session"""
    scope: builtins.str
    def __init__(
        self,
        *,
        session: builtins.str = ...,
        scope: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["scope", b"scope", "session", b"session"]) -> None: ...

global___GetChatHistoryRequest = GetChatHistoryRequest

class ChatHistoryEntry(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    CONTENT_FIELD_NUMBER: builtins.int
    type: builtins.str
    content: builtins.str
    def __init__(
        self,
        *,
        type: builtins.str = ...,
        content: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["content", b"content", "type", b"type"]) -> None: ...

global___ChatHistoryEntry = ChatHistoryEntry

class GetChatHistoryResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ENTRIES_FIELD_NUMBER: builtins.int
    @property
    def entries(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ChatHistoryEntry]: ...
    def __init__(
        self,
        *,
        entries: collections.abc.Iterable[global___ChatHistoryEntry] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["entries", b"entries"]) -> None: ...

global___GetChatHistoryResponse = GetChatHistoryResponse

class SimulationParamToSdkCodeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SIMULATION_PARAM_FIELD_NUMBER: builtins.int
    @property
    def simulation_param(self) -> luminarycloud._proto.client.simulation_pb2.SimulationParam: ...
    def __init__(
        self,
        *,
        simulation_param: luminarycloud._proto.client.simulation_pb2.SimulationParam | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["simulation_param", b"simulation_param"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["simulation_param", b"simulation_param"]) -> None: ...

global___SimulationParamToSdkCodeRequest = SimulationParamToSdkCodeRequest

class SimulationParamToSdkCodeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SDK_CODE_FIELD_NUMBER: builtins.int
    sdk_code: builtins.str
    def __init__(
        self,
        *,
        sdk_code: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["sdk_code", b"sdk_code"]) -> None: ...

global___SimulationParamToSdkCodeResponse = SimulationParamToSdkCodeResponse
