# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from google.protobuf.message import Message as _Message

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.param_wrappers._lib import ParamGroupWrapper, CodeRepr, create_unique_id


@dataclass(kw_only=True)
class Adjoint(CodeRepr, ParamGroupWrapper[clientpb.Adjoint]):
    """Settings for adjoint sensitivity analysis."""

    output: Optional[Any] = None
    "Function to differentiate."
    surfaces: list[str] = field(default_factory=list)
    ""
    deformed_coords_id: str = ""
    "Upload ID of the file containing deformed coordinates for design surfaces. Setting this to 'template' instructs the solver to output a file with the current surface coordinates."
    primal_simulation_id: str = ""
    "ID of the primal simulation to differentiate."

    def _to_proto(self) -> clientpb.Adjoint:
        _proto = clientpb.Adjoint()
        if self.output is not None:
            _proto.adjoint_output.CopyFrom(self.output)
        if self.surfaces is not None:
            _proto.surfaces.extend(self.surfaces)
        if self.deformed_coords_id is not None:
            _proto.deformed_coords_id = self.deformed_coords_id
        if self.primal_simulation_id is not None:
            _proto.primal_simulation_id = self.primal_simulation_id
        return _proto

    def _from_proto(self, proto: clientpb.Adjoint) -> None:
        self.output = proto.adjoint_output
        self.surfaces.extend(proto.surfaces)
        self.deformed_coords_id = proto.deformed_coords_id
        self.primal_simulation_id = proto.primal_simulation_id
        return None
